/**************************************************************************************************************************
// This script was authored by Lorne Brooks - Email: lbtools2k@gmail.com
//
//
// This is a highly modified version of another script by the same name authored by Jim Jagger.
// Icons used in this script were also created by Jim Jagger.
//
//
// REVISION HISTORY:
// Version 1.2 27/10/14;
//						- Email change for help contact.
// Version 1.1 14/09/12;
//						- Recoded script as a struct to minimize global variables.
//						- Bug fixes.
// Version 1.0 22/05/08;
//						- First public release
//
//
// This script is not copyrighted, please feel free to modify or distribute.
//
**************************************************************************************************************************/

global g_LBTools_PBT

struct s_LBTools_playbackTools
(

/*==================================================================================
// Structure variables
====================================================================================*/
	
PlaybackTools_floater,
dPos,
Controls_Rollout,
SavedRanges_Rollout,
EditRange_Rollout,
TimeScrub_Rollout,
aboutScript_rollout,
f_timeRangeUpdate,
f_openPlaybackTools,
f_compactSliderDialog,
f_hideUI,
startTime = (animationRange.start as integer) / ticksPerFrame,		
endTime = (animationRange.end as integer) / ticksPerFrame,
theIniFile = (getDir #plugcfg) + "\PlaybackTools.ini",
rangeStr = "",

/*==================================================================================*/

fn f_playbackTools =
(		
	fn f_scrubberUpdate =
	(
		g_LBTools_PBT.Controls_Rollout.sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
		g_LBTools_PBT.TimeScrub_Rollout.sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
	)
	
	fn f_timeRangeUpdate =
	(
		g_LBTools_PBT.Controls_Rollout.spn_TRstart.range = [-100000,100000,(animationRange.start as integer) / ticksPerFrame]
		g_LBTools_PBT.Controls_Rollout.spn_TRend.range = [-100000,100000,(animationRange.end as integer) / ticksPerFrame]
	)
	
	fn f_compactSliderDialog =
	(
		g_LBTools_PBT.dPos = g_LBTools_PBT.PlaybackTools_floater.pos
		try(closerolloutfloater g_LBTools_PBT.PlaybackTools_floater)catch()
		createDialog g_LBTools_PBT.TimeScrub_Rollout 800 50 pos:(mouse.screenpos + [-180,-15]) style:#(#style_toolwindow, #style_sysmenu)
	)
	
	fn f_openPlaybackTools =
	(
		try(closerolloutfloater g_LBTools_PBT.PlaybackTools_floater)catch()
		g_LBTools_PBT.PlaybackTools_floater = newrolloutfloater "PBT" 190 270
		if g_LBTools_PBT.dPos == undefined do
		(
			g_LBTools_PBT.dPos = mouse.screenpos + [-70,-10]
		)
		g_LBTools_PBT.PlaybackTools_floater.pos = g_LBTools_PBT.dPos
		addRollout g_LBTools_PBT.Controls_Rollout g_LBTools_PBT.PlaybackTools_floater rolledup:false
		addRollout g_LBTools_PBT.SavedRanges_Rollout g_LBTools_PBT.PlaybackTools_floater rolledup:true
		addRollout g_LBTools_PBT.aboutScript_rollout g_LBTools_PBT.PlaybackTools_floater rolledup:true
	)
	
	fn f_hideUI =
	(
		local state = not(timeslider.isVisible()) 
		trackbar.visible = state
		timeSlider.setVisible state
		if state then
		(
			cui.expertModeOff()
		)
		else
		(
			cui.expertModeOn()
		)
		statusPanel.visible = state
	)
	
	-------------------------------------------------------------------------------------------------
	--// Rollouts
	-------------------------------------------------------------------------------------------------
	
	rollout TimeScrub_Rollout "PBT - Time Scrubber"
	(
		slider sld_scrubme range:[animationRange.start,animationRange.end,sliderTime] width:760 offset:[5,0] ticks:0 across:2
		button btn_hideUI "UI" width:22 height:22 offset:[190,0] tooltip:"Toggles hiding the UI on and off"
		button btn_expand "" width:730 height:8 offset:[-5,0] tooltip:"Closes the dialog and loads the full Playback Tools floater"
	
		on TimeScrub_Rollout moved val do
		(
			g_LBTools_PBT.dPos = val
		)
		
		on sld_scrubme changed t do
		(
			sliderTime = t
		)
		
		on btn_expand pressed do
		(
			try(destroyDialog g_LBTools_PBT.TimeScrub_Rollout)catch()
			g_LBTools_PBT.f_openPlaybackTools()
		)
		
		on btn_hideUI pressed do
		(
			g_LBTools_PBT.f_hideUI()
		)
	) --// end rollout
	
	rollout Controls_Rollout "Playing"
	(
		local imageFile1 = (getDir #userIcons) + "\PlaybackTools_Begin.bmp"
		local imageFile2 = (getDir #userIcons) + "\PlaybackTools_End.bmp"
		local imageFile3 = (getDir #userIcons) + "\PlaybackTools_KeyToggle.bmp"
		local imageFile4 = (getDir #userIcons) + "\PlaybackTools_NextFrame.bmp"
		local imageFile5 = (getDir #userIcons) + "\PlaybackTools_NextKey.bmp"
		local imageFile6 = (getDir #userIcons) + "\PlaybackTools_Play.bmp"
		local imageFile7 = (getDir #userIcons) + "\PlaybackTools_PreviousFrame.bmp"
		local imageFile8 = (getDir #userIcons) + "\PlaybackTools_PreviousKey.bmp"
		
		button btn_begin pos:[14,5] width:16 height:16 images:#(imageFile1, undefined, 1, 1, 1, 1, 1) tooltip:"Start Frame"
		button btn_previousKey pos:[(btn_begin.pos.x)+17,btn_begin.pos.y] width:16 height:16 images:#(imageFile8, undefined, 1, 1, 1, 1, 1) tooltip:"Previous Key Frame"
		button btn_previousFrame pos:[(btn_previousKey.pos.x)+17,btn_begin.pos.y] width:16 height:16 images:#(imageFile7, undefined, 1, 1, 1, 1, 1) tooltip:"Previous Frame"
		checkbutton chkbtn_play pos:[(btn_previousFrame.pos.x)+17,btn_begin.pos.y] width:50 height:16 images:#(imageFile6, undefined, 1, 1, 1, 1, 1) tooltip:"Play"
		button btn_nextFrame pos:[(chkbtn_play.pos.x)+51,btn_begin.pos.y] width:16 height:16 images:#(imageFile4, undefined, 1, 1, 1, 1, 1) tooltip:"Next Frame"
		button btn_nextKey pos:[(btn_nextFrame.pos.x)+17,btn_begin.pos.y] width:16 height:16 images:#(imageFile5, undefined, 1, 1, 1, 1, 1) tooltip:"Next Key Frame"
		button btn_end pos:[(btn_nextKey.pos.x)+17,btn_begin.pos.y] width:16 height:16 images:#(imageFile2, undefined, 1, 1, 1, 1, 1) tooltip:"End Frame"
		
		group "Playback Speed"
		(
			radiobuttons rbtn_playSpeed labels:#("1/4", "1/2", "1x", "2x", "4x") default:timeConfiguration.playbackSpeed align:#center offset:[30,0] columns:3 across:2
			checkbox chkbx_realtime "Real Time" align:#right offset:[9,15]
		)
		
		group "Time Scrubber"
		(
			slider sld_scrubme range:[animationRange.start,animationRange.end,sliderTime] width:140 offset:[0,0] ticks:0 across:2
			button btn_hideUI "UI" width:22 height:22 offset:[30,0] tooltip:"Toggles hiding the UI on and off"
			button btn_compact "" width:150 height:8 tooltip:"Closes the floater and loads a dialog showing only the time scrubber"
		)
	
		group "Time Range"
		(
			spinner spn_TRstart "" width:50 height:16 range:[-100000,100000,g_LBTools_PBT.startTime] type:#integer across:3 align:#right
			spinner spn_TRslide "slide " width:20 height:16 range:[-100000,100000,(animationRange.start as integer)/ticksPerFrame] type:#integer align:#center offset:[10,0]
			spinner spn_TRend "" width:50 height:16 range:[-100000,100000,g_LBTools_PBT.endTime] type:#integer align:#left
		)
		
		-------------------------------------------------------------------------------------------------
		--// Event handlers
		-------------------------------------------------------------------------------------------------
	
		on Controls_Rollout open do
		(
			if realTimePlayback then
			(
				chkbx_realtime.checked = true
				rbtn_playSpeed.enabled = true
			)
			else
			(
				chkbx_realtime.checked = false
				rbtn_playSpeed.enabled = false
			)
		)
		
		on Controls_Rollout moved val do
		(
			rbtn_playSpeed.state = timeconfiguration.playbackspeed
			if realTimePlayback then
			(
				chkbx_realtime.checked = true
				rbtn_playSpeed.enabled = true
			)
			else
			(
				chkbx_realtime.checked = false
				rbtn_playSpeed.enabled = false
			)
			g_LBTools_PBT.dPos = val
		)
	
		on Controls_Rollout close do
		(
			stopanimation()
		)
		
		on chkbx_realtime changed state do
		(
			if state then
			(
				realTimePlayback = true
				rbtn_playSpeed.enabled = true
			)
			else
			(
				realTimePlayback = false
				rbtn_playSpeed.enabled = false
			)
		)
	
		on btn_nextFrame pressed do
		(	
			sliderTime += 1
			sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
		)
							
		on btn_nextKey pressed do
		(	
			try
			(
				sliderTime = (trackbar.getnextKeyTime() as integer) / ticksperframe
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
			)catch()
		)
		
		on btn_previousFrame pressed do
		(	
			sliderTime -= 1
			sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
		)
		
		on btn_previousKey pressed do
		(	
			try
			(
				sliderTime = (trackbar.getpreviousKeyTime() as integer) / ticksPerFrame
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
			)catch()
		)
				
		on btn_end pressed do
		(
			sliderTime = (animationRange.end as integer ) / ticksPerFrame
			sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
		)
		
		on btn_begin pressed do
		(
			sliderTime = (animationRange.start as integer ) / ticksPerFrame
			sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
		)
		
		on chkbtn_play changed state do
		(
			if realTimePlayback then
			(
				chkbx_realtime.checked = true
				rbtn_playSpeed.enabled = true
			)
			else
			(
				chkbx_realtime.checked = false
				rbtn_playSpeed.enabled = false
			)
			if state == true then 
			(
				playanimation()
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
			)
			else
			( 
				stopanimation() 
			)
		)
	
		on rbtn_playSpeed changed state do
		(
			case rbtn_playSpeed.state of
			(
				1: timeconfiguration.playbackspeed = 1 --// 1/4 speed
				2: timeconfiguration.playbackspeed = 2 --// 1/2 speed
				3: timeconfiguration.playbackspeed = 3 --// 1x speed
				4: timeconfiguration.playbackspeed = 4 --// 2x speed
				5: timeconfiguration.playbackspeed = 5 --// 4x speed
			)
		)
		
		on sld_scrubme changed t do
		(
			sliderTime = t
		)
	
		on btn_hideUI pressed do g_LBTools_PBT.f_hideUI()
	
		on btn_compact pressed do
		(
			g_LBTools_PBT.f_compactSliderDialog()
		)

		on spn_TRstart changed val do
		(
			local endVal = spn_TRend.value
			if val < endVal then
		 	(
				animationRange = interval val spn_TRend.value
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
		 	)
			else
			(
				spn_TRend.value = val + 1
				animationRange = interval val spn_TRend.value
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
			) 
		)
	
		on spn_TRend changed val do
		(
			local startVal = spn_TRstart.value
		    if val > startVal then
			(
				animationRange = interval spn_TRstart.value val
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
			)
			else
			(
				spn_TRstart.value = val - 1
				animationRange = interval spn_TRstart.value val
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
			)
		)
		
		on spn_TRslide changed val do
		(
			if val > 0 do
			(
				spn_TRstart.value = spn_TRstart.value + 1
				spn_TRend.value = spn_TRend.value + 1
				animationRange = interval spn_TRstart.value spn_TRend.value
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
				spn_TRslide.value = 0
			)
			
			if val < 0 do
			(
				spn_TRstart.value = spn_TRstart.value - 1
				spn_TRend.value = spn_TRend.value - 1
				animationRange = interval spn_TRstart.value spn_TRend.value
				sld_scrubme.range = [animationRange.start,animationRange.end,sliderTime]
				spn_TRslide.value = 0
			)
		)
	) --// end rollout
	
	rollout EditRange_Rollout "Edit Range"
	(
	
		spinner spn_startVal "Start: " width:80 height:16 range:[-100000,100000,g_LBTools_PBT.endTime] type:#integer align:#left
		spinner spn_endVal "End:  " width:80 height:16 range:[-100000,100000,g_LBTools_PBT.startTime] type:#integer align:#left
	
		on EditRange_Rollout open do
		(
			local FRstring = getIniSetting g_LBTools_PBT.theIniFile g_LBTools_PBT.rangeStr "Set to"
			local FRss = stringStream FRstring
			local savedRange = readValue FRss
			spn_startVal.value = savedRange[1]
			spn_endVal.value = savedRange[2]
		)
		
		on EditRange_Rollout close do
		(
			local rangeValues = [spn_startVal.value, spn_endVal.value]
			delIniSetting g_LBTools_PBT.theIniFile g_LBTools_PBT.rangeStr
			setIniSetting g_LBTools_PBT.theIniFile g_LBTools_PBT.rangeStr "Set to " (rangeValues as string)
			local str_rangeDisplay = ("[ " + (rangeValues[1] as integer) as string + "..." + (rangeValues[2] as integer) as string + " ]")
			case g_LBTools_PBT.rangeStr of
			(
				"Range1" : if g_LBTools_PBT.PlaybackTools_floater.open do (g_LBTools_PBT.SavedRanges_Rollout.btn_store_1.caption = str_rangeDisplay)
				"Range2" : if g_LBTools_PBT.PlaybackTools_floater.open do (g_LBTools_PBT.SavedRanges_Rollout.btn_store_2.caption = str_rangeDisplay)
				"Range3" : if g_LBTools_PBT.PlaybackTools_floater.open do (g_LBTools_PBT.SavedRanges_Rollout.btn_store_3.caption = str_rangeDisplay)
				"Range4" : if g_LBTools_PBT.PlaybackTools_floater.open do (g_LBTools_PBT.SavedRanges_Rollout.btn_store_4.caption = str_rangeDisplay)
			)
		)
			
		on spn_startVal changed val do
		(
			local endVal = spn_endVal.value
	    	if val >= endVal do
			(
				spn_endVal.value = val + 1
			)
		)
		
		on spn_endVal changed val do
		(
			local startVal = spn_startVal.value
		    if val <= startVal do
			(
				spn_startVal.value = val - 1
			)
		)
	) --// end rollout
	
	rollout SavedRanges_Rollout "Saved Ranges"
	(
	
		button btn_saved_1 "Goto" width:33 height:22 align:#left across:4 offset:[-9,0] tooltip:"Time range becomes this saved range"
		button btn_store_1 "FREE" width:80 height:22 align:#center offset:[12,0] tooltip:"Save the current range"
		button btn_unlock_1 "U" width:20 height:22 align:#center offset:[28,0] tooltip:"Unlock then save a new range"
		button btn_edit_1 "[...]" width:24 height:22 align:#right offset:[10,0] tooltip:"Edit and save range values" --enabled:rangeAvailable
		editText edtxt_saved_1 align:#left fieldwidth:170 offset:[-14,0]
	
		button btn_saved_2 "Goto" width:33 height:22 align:#left across:4 offset:[-9,0] tooltip:"Time range becomes this saved range"
		button btn_store_2 "FREE" width:80 height:22 align:#center offset:[12,0] tooltip:"Save the current range"
		button btn_unlock_2 "U" width:20 height:22 align:#center offset:[28,0] tooltip:"Unlock then save a new range"
		button btn_edit_2 "[...]" width:24 height:22 align:#right offset:[10,0] tooltip:"Edit and save range values" --enabled:rangeAvailable
		editText edtxt_saved_2 align:#left fieldwidth:170 offset:[-14,0]
	
		button btn_saved_3 "Goto" width:33 height:22 align:#left across:4 offset:[-9,0] tooltip:"Time range becomes this saved range"
		button btn_store_3 "FREE" width:80 height:22 align:#center offset:[12,0] tooltip:"Save the current range"
		button btn_unlock_3 "U" width:20 height:22 align:#center offset:[28,0] tooltip:"Unlock then save a new range"
		button btn_edit_3 "[...]" width:24 height:22 align:#right offset:[10,0] tooltip:"Edit and save range values" --enabled:rangeAvailable
		editText edtxt_saved_3 align:#left fieldwidth:170 offset:[-14,0]
		
		button btn_saved_4 "Goto" width:33 height:22 align:#left across:4 offset:[-9,0] tooltip:"Time range becomes this saved range"
		button btn_store_4 "FREE" width:80 height:22 align:#center offset:[12,0] tooltip:"Save the current range"
		button btn_unlock_4 "U" width:20 height:22 align:#center offset:[28,0] tooltip:"Unlock then save a new range"
		button btn_edit_4 "[...]" width:24 height:22 align:#right offset:[10,0] tooltip:"Edit and save range values" --enabled:rangeAvailable
		editText edtxt_saved_4 align:#left fieldwidth:170 offset:[-14,0]
				
		button btn_start "[=--" width:22 height:22 offset:[-4,0] across:6 tooltip:"Start of range becomes the slider time"
		button btn_minus30 "<+30" width:30 height:22 offset:[-2,0] tooltip:"Start of range extended 30 frames"
		button btn_timeConfig "TC" width:22 height:22 offset:[0,0] tooltip:"Load the Time Config dialog"
		button btn_add30 "30+>" width:30 height:22 offset:[9,0] tooltip:"End of range extended 30 frames"
		button btn_end "--=]" width:22 height:22 offset:[11,0] tooltip:"End of range becomes the slider time"\
		button btn_delINI "Del" width:26 height:22 offset:[12,0] tooltip:"Delete the INI file and all stored ranges"
	
		-------------------------------------------------------------------------------------------------
		-- Event handlers
		-------------------------------------------------------------------------------------------------		
	
		on SavedRanges_Rollout open do
		(
			local FRstring1 = getIniSetting g_LBTools_PBT.theIniFile "Range1" "Set to"
			if FRstring1 != "" then
			(
				local FRss1 = stringStream FRstring1
				local savedRange1 = readValue FRss1
				local rangeDisplay = ("[ " + (savedRange1[1] as integer) as string + "..." + (savedRange1[2] as integer) as string + " ]")
				btn_store_1.caption = rangeDisplay
				btn_store_1.enabled = false
				local Tstring1 = getIniSetting g_LBTools_PBT.theIniFile "Text1" "Name"
				edtxt_saved_1.text = Tstring1
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_1.enabled = true
			)
			else
			(
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_1.enabled = false
			)
			
			local FRstring2 = getIniSetting g_LBTools_PBT.theIniFile "Range2" "Set to"
			if FRstring2 != "" then
			(
				local FRss2 = stringStream FRstring2
				local savedRange2 = readValue FRss2
				local rangeDisplay = ("[ " + (savedRange2[1] as integer) as string + "..." + (savedRange2[2] as integer) as string + " ]")
				btn_store_2.caption = rangeDisplay
				btn_store_2.enabled = false
				local Tstring2 = getIniSetting theIniFile "Text2" "Name"
				edtxt_saved_2.text = Tstring2
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_2.enabled = true
			)
			else
			(
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_2.enabled = false
			)
			
			local FRstring3 = getIniSetting g_LBTools_PBT.theIniFile "Range3" "Set to"
			if FRstring3 != "" then
			(
				local FRss3 = stringStream FRstring3
				local savedRange3 = readValue FRss3
				local rangeDisplay = ("[ " + (savedRange3[1] as integer) as string + "..." + (savedRange3[2] as integer) as string + " ]")
				btn_store_3.caption = rangeDisplay
				btn_store_3.enabled = false
				local Tstring3 = getIniSetting g_LBTools_PBT.theIniFile "Text3" "Name"
				edtxt_saved_3.text = Tstring3
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_3.enabled = true
			)
			else
			(
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_3.enabled = false
			)
			
			local FRstring4 = getIniSetting g_LBTools_PBT.theIniFile "Range4" "Set to"
			if FRstring4 != "" then
			(
				local FRss4 = stringStream FRstring4
				local savedRange4 = readValue FRss4
				local rangeDisplay = ("[ " + (savedRange4[1] as integer) as string + "..." + (savedRange4[2] as integer) as string + " ]")
				btn_store_4.caption = rangeDisplay
				btn_store_4.enabled = false
				local Tstring4 = getIniSetting g_LBTools_PBT.theIniFile "Text4" "Name"
				edtxt_saved_4.text = Tstring4
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_4.enabled = true
			)
			else
			(
				g_LBTools_PBT.SavedRanges_Rollout.btn_edit_4.enabled = false
			)
		)

		on btn_saved_1 pressed do
		(
			local FRstring = getIniSetting g_LBTools_PBT.theIniFile "Range1" "Set to"
			local FRss = stringStream FRstring
			local savedRange = readValue FRss
			animationRange = interval savedRange[1] savedRange[2]
			sliderTime = savedRange[1]
		)
		
		on btn_store_1 pressed do
		(
			g_LBTools_PBT.SavedRanges_Rollout.btn_edit_1.enabled = true
			local rangeValues = [animationRange.start, animationRange.end]
			delIniSetting g_LBTools_PBT.theIniFile "Range1"
			setIniSetting g_LBTools_PBT.theIniFile "Range1" "Set to " (rangeValues as string)
			local rangeDisplay = ("[ " + (rangeValues[1] as integer) as string + "..." + (rangeValues[2] as integer) as string + " ]")
			btn_store_1.caption = rangeDisplay
			btn_store_1.enabled = false
		)
		
		on btn_unlock_1 pressed do
		(
			btn_store_1.enabled = true
		)
		
		on btn_edit_1 pressed do
		(
			g_LBTools_PBT.rangeStr = "Range1"
			try(destroyDialog g_LBTools_PBT.EditRange_Rollout)catch()
			createDialog g_LBTools_PBT.EditRange_Rollout pos:g_LBTools_PBT.dPos width:120
		)
		
		on edtxt_saved_1 changed txt do
		(
			delIniSetting g_LBTools_PBT.theIniFile "Text1"
			setIniSetting g_LBTools_PBT.theIniFile "Text1" "Name " (txt as string)
		)

		on btn_saved_2 pressed do
		(
			local FRstring = getIniSetting g_LBTools_PBT.theIniFile "Range2" "Set to"
			local FRss = stringStream FRstring
			local savedRange = readValue FRss
			animationRange = interval savedRange[1] savedRange[2]
			sliderTime = savedRange[1]
		)
		
		on btn_store_2 pressed do
		(
			g_LBTools_PBT.SavedRanges_Rollout.btn_edit_2.enabled = true
			local rangeValues = [animationRange.start, animationRange.end]
			delIniSetting g_LBTools_PBT.theIniFile "Range2"
			setIniSetting g_LBTools_PBT.theIniFile "Range2" "Set to " (rangeValues as string)
			local rangeDisplay = ("[ " + (rangeValues[1] as integer) as string + "..." + (rangeValues[2] as integer) as string + " ]")
			btn_store_2.caption = rangeDisplay
			btn_store_2.enabled = false
		)
		
		on btn_unlock_2 pressed do
		(
			btn_store_2.enabled = true
		)
		
		on btn_edit_2 pressed do
		(
			g_LBTools_PBT.rangeStr = "Range2"
			try(destroyDialog g_LBTools_PBT.EditRange_Rollout)catch()
			createDialog g_LBTools_PBT.EditRange_Rollout pos:g_LBTools_PBT.dPos width:120
		)
		
		on edtxt_saved_2 changed txt do
		(
			delIniSetting g_LBTools_PBT.theIniFile "Text2"
			setIniSetting g_LBTools_PBT.theIniFile "Text2" "Name " (txt as string)
		)

		on btn_saved_3 pressed do
		(
			local FRstring = getIniSetting g_LBTools_PBT.theIniFile "Range3" "Set to"
			local FRss = stringStream FRstring
			local savedRange = readValue FRss
			animationRange = interval savedRange[1] savedRange[2]
			sliderTime = savedRange[1]
		)
		
		on btn_store_3 pressed do
		(
			g_LBTools_PBT.SavedRanges_Rollout.btn_edit_3.enabled = true
			local rangeValues = [animationRange.start, animationRange.end]
			delIniSetting g_LBTools_PBT.theIniFile "Range3"
			setIniSetting g_LBTools_PBT.theIniFile "Range3" "Set to " (rangeValues as string)
			local rangeDisplay = ("[ " + (rangeValues[1] as integer) as string + "..." + (rangeValues[2] as integer) as string + " ]")
			btn_store_3.caption = rangeDisplay
			btn_store_3.enabled = false
		)
		
		on btn_unlock_3 pressed do
		(
			btn_store_3.enabled = true
		)
		
		on btn_edit_3 pressed do
		(
			g_LBTools_PBT.rangeStr = "Range3"
			try(destroyDialog g_LBTools_PBT.EditRange_Rollout)catch()
			createDialog g_LBTools_PBT.EditRange_Rollout pos:g_LBTools_PBT.dPos width:120
		)
		
		on edtxt_saved_3 changed txt do
		(
			delIniSetting g_LBTools_PBT.theIniFile "Text3"
			setIniSetting g_LBTools_PBT.theIniFile "Text3" "Name " (txt as string)
		)

		on btn_saved_4 pressed do
		(
			local FRstring = getIniSetting g_LBTools_PBT.theIniFile "Range4" "Set to"
			local FRss = stringStream FRstring
			local savedRange = readValue FRss
			animationRange = interval savedRange[1] savedRange[2]
			sliderTime = savedRange[1]
		)
		
		on btn_store_4 pressed do
		(
			g_LBTools_PBT.SavedRanges_Rollout.btn_edit_4.enabled = true
			local rangeValues = [animationRange.start, animationRange.end]
			delIniSetting g_LBTools_PBT.theIniFile "Range4"
			setIniSetting g_LBTools_PBT.theIniFile "Range4" "Set to " (rangeValues as string)
			local rangeDisplay = ("[ " + (rangeValues[1] as integer) as string + "..." + (rangeValues[2] as integer) as string + " ]")
			btn_store_4.caption = rangeDisplay
			btn_store_4.enabled = false
		)
		
		on btn_unlock_4 pressed do
		(
			btn_store_4.enabled = true
		)
		
		on btn_edit_4 pressed do
		(
			g_LBTools_PBT.rangeStr = "Range4"
			try(destroyDialog g_LBTools_PBT.EditRange_Rollout)catch()
			createDialog g_LBTools_PBT.EditRange_Rollout pos:g_LBTools_PBT.dPos width:120
		)
		
		on edtxt_saved_4 changed txt do
		(
			delIniSetting g_LBTools_PBT.theIniFile "Text4"
			setIniSetting g_LBTools_PBT.theIniFile "Text4" "Name " (txt as string)
		)
		
		on btn_delINI pressed do
		(
			if queryBox "This will reset all the stored ranges... continue?" title:"" do
			(
				local str_configFolder = getDir #plugcfg
				deleteFile (str_configFolder as string + "\PlaybackTools.ini")
				g_LBTools_PBT.f_openPlaybackTools()
			)
		)

		on btn_start pressed do
		(
			animationRange = interval sliderTime animationRange.end
		)
	
		on btn_minus30 pressed do
		(
			local newStart = animationRange.start - 30
			animationRange = interval newStart animationRange.end
		)
		
		on btn_timeConfig pressed do
		(
			max time config
		)
		
		on btn_add30 pressed do
		(
			local newEnd = animationRange.end + 30
			animationRange = interval animationRange.start newEnd
		)
	
		on btn_end pressed do
		(
			if sliderTime > animationRange.start do
			(
				animationRange = interval animationRange.start sliderTime
			)
		)
	) --// end rollout
	
	rollout aboutScript_rollout "About"
	(
		label lbl_author "Author - Lorne Brooks"
		hyperLink myEmail "lbtools2k@gmail.com" color:(color 0 0 255) hovercolor:(color 0 0 190) visitedcolor:(color 190 0 0) align:#center address:"mailto:lbtools2k@gmail.com"
		label lbl_version "Version 1.2 - 27 Oct 2014"
	) --// end rollout
	
	f_openPlaybackTools()

	-------------------------------------------------------------------------------------------------
	--// Callbacks
	-------------------------------------------------------------------------------------------------
	registerTimeCallback f_scrubberUpdate
	callbacks.addScript #animationRangeChange "g_LBTools_PBT.f_timeRangeUpdate()" id:#updateRange

) --// end function

) --// end struct

g_LBTools_PBT = s_LBTools_playbackTools()


/*********************************************************************************************************************************************************************/
--// MACRO CALLS FOR UI
/*********************************************************************************************************************************************************************/

macroscript playbackTools
	category:"LB Tools"
	buttontext:"{ PBT }"
	tooltip:"Playback Tools 1.2"
(
	g_LBTools_PBT.f_playbackTools()
)

/*********************************************************************************************************************************************************************/